#ifndef GAP_WS_WINDOW_H
#define GAP_WS_WINDOW_H

#include <moo/docwindow.h>
#include <moo/pimpl.h>
#include <moo/enum.h>
#include <QDialog>
#include <QPrinter>

namespace Ui {
class WsWindow;
}

namespace ggap {

class Worksheet;
class WsWindowPrivate;

class WsWindow : public moo::DocumentWindow {
    Q_OBJECT
    M_DECLARE_IMPL(WsWindow)

    Ui::WsWindow *ui;
    ggap::Worksheet *ws();

public:
    WsWindow(bool terminalMode);

    virtual void present(moo::DocumentWindow *old);

protected:
    ~WsWindow();

    virtual void printDocument(QPrinter *printer);
    virtual void setupPrintDialog(QPrintDialog *dlg);

public:
    moo::Document *document();

private:
    void init(bool terminalMode);
    virtual void applyPrefs();

    virtual QList<QUrl> openFileDialog();
    virtual QUrl saveFileDialog(QString *type);

private Q_SLOTS:
    void gapStateChanged();

    void actionNewWorksheet();
    void actionNewTerminal();
};

} // namespace ggap

#endif // GAP_WS_WINDOW_H
